/* Initialize UART */ 		  
void UART_Init (unsigned long baudrate) { 
  /* Set the baud rate */   
  //Assumes 8Mhz clock in single speed (U2X=0) mode
  switch(baudrate){
  case 9600:   UBRRL = 51; break; //.2% error
  case 19200:  UBRRL = 25; break; //.2% error
  case 38400:  UBRRL = 12; break; //.2% error
  case 57600:  UBRRL = 8; break;  //-3.5% error
  case 115200: UBRRL = 1; break;  //8.5% error
  default: UBRRL=12;
  }

  /* Enable UART receiver and transmitter */   
  UCSRB = (1 << RXEN) | (1 << TXEN);   
  /* set to 8 data bits, 1 stop bit */   
  UCSRC = (1<<UCSZ1) | (1<<UCSZ0); } 

/* Read and write functions */ 
unsigned char UART_InChar (void) {   
  /* Wait for incomming data */   
  while (!(UCSRA & (1 << RXC)));   
  /* Return the data */   
  return UDR; 
} 

void UART_OutChar (unsigned char data) {   
  /* Wait for empty transmit buffer */   
  while (!(UCSRA & (1 << UDRE)));   
  /* Start transmittion */   
  UDR = data; 
}
